Heatsink = LibStub("AceAddon-3.0"):NewAddon("Heatsink", "AceEvent-3.0")
local addon = Heatsink
local db

local L = LibStub:GetLibrary("AceLocale-3.0"):GetLocale("Heatsink")
local candy = LibStub("LibCandyBar-3.0")
local media = LibStub("LibSharedMedia-3.0")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local Gratuity = LibStub("LibGratuity-3.0")
local itemSlots = {"Trinket0Slot", "Trinket1Slot", "Finger0Slot", "Finger1Slot", "HeadSlot"}
local playerGUID, playerClass

local CreateFrame = _G.CreateFrame
local GameFontNormal = _G.GameFontNormal
local GetContainerItemCooldown = _G.GetContainerItemCooldown
local GetContainerItemInfo = _G.GetContainerItemInfo
local GetContainerItemLink = _G.GetContainerItemLink
local GetContainerNumSlots = _G.GetContainerNumSlots
local GetInventoryItemCooldown = _G.GetInventoryItemCooldown
local GetInventoryItemLink = _G.GetInventoryItemLink
local GetInventoryItemTexture = _G.GetInventoryItemTexture
local GetInventorySlotInfo = _G.GetInventorySlotInfo
local GetItemInfo = _G.GetItemInfo
local GetRealZoneText = _G.GetRealZoneText
local GetSpellCooldown = _G.GetSpellCooldown
local GetSpellInfo = _G.GetSpellInfo
local GetTime = _G.GetTime
local IsActiveBattlefieldArena = _G.IsActiveBattlefieldArena
local UnitClass = _G.UnitClass
local UnitGUID = _G.UnitGUID

local ipairs = _G.ipairs
local pairs = _G.pairs
local select = _G.select
local string = _G.string
local tonumber = _G.tonumber
local tostring = _G.tostring
local tinsert = _G.table.insert
local tsort = _G.table.sort
local unpack = _G.unpack
local wipe = _G.wipe

local BOOKTYPE_PET = _G.BOOKTYPE_PET
local BOOKTYPE_SPELL = _G.BOOKTYPE_SPELL
local STRING_SCHOOL_ARCANE = _G.STRING_SCHOOL_ARCANE
local STRING_SCHOOL_FIRE = _G.STRING_SCHOOL_FIRE
local STRING_SCHOOL_FROST = _G.STRING_SCHOOL_FROST
local STRING_SCHOOL_HOLY = _G.STRING_SCHOOL_HOLY
local STRING_SCHOOL_NATURE = _G.STRING_SCHOOL_NATURE
local STRING_SCHOOL_PHYSICAL = _G.STRING_SCHOOL_PHYSICAL
local STRING_SCHOOL_SHADOW = _G.STRING_SCHOOL_SHADOW

local defaults = {
	profile = {
		sinkOptions = {},
		min = 3,
		max = 3600,
		growth = true,
		texture = "default",
		scale = 1,
		width = 200,
		height = 10,
		font = "ABF",
		fontsize = 10,
		school = true,
		showSpells = true,
		showPet = true,
		showItems = true,
		showBags = true,
		showInternal = true,
		anchor = {
			x = 0,
			y = 0,
			width = 250,
			pos = {"CENTER", "UIParent", "CENTER", 0, -50},
		},
		colors = {
			bg = { 0.5, 0.5, 0.5, 0.3 },
			text = { 1, 1, 1 },
			bar = { 0.25, 0.33, 0.68, 1 },
		},
	},
}

local groupedCooldowns = {
	[(GetSpellInfo(1499))] = L["Traps"], -- 1499 Freezing Trap
	[(GetSpellInfo(13795))] = L["Traps"], -- 13795 Immolation Trap
	[(GetSpellInfo(13809))] = L["Traps"], -- 13909 Immolation Trap
	[(GetSpellInfo(13813))] = L["Traps"], -- 13813 Explosive Trap
	[(GetSpellInfo(34600))] = L["Traps"], -- 34600 Snake Trap

	[(GetSpellInfo(8042))] = L["Shocks"], -- 8042 Earth Shock
	[(GetSpellInfo(8056))] = L["Shocks"], -- 8056 Frost Shock
	[(GetSpellInfo(8050))] = L["Shocks"], -- 8050 Flame Shock
	
	[(GetSpellInfo(53408))] = L["Judgement"], -- Judgement of Wisdom
	[(GetSpellInfo(20271))] = L["Judgement"], -- Judgement of Light
	[(GetSpellInfo(53407))] = L["Judgement"], -- Judgement of Justice

	[(GetSpellInfo(16979))] = (GetSpellInfo(49377)), -- 16979 Feral Charge - Bear, 49377 Feral Charge (Talent)
	[(GetSpellInfo(49376))] = (GetSpellInfo(49377)), -- 16979 Feral Charge - Cat,  49377 Feral Charge (Talent)
}

local groupedBagCooldowns = {
	[L["Mana Jade"]] = L["Stones"],
	[L["Mana Ruby"]] = L["Stones"],
	[L["Mana Citrine"]] = L["Stones"],
	[L["Mana Agate"]] = L["Stones"],
	[L["Mana Emerald"]] = L["Stones"],
	[L["Healthstone$"]] = L["Stones"],

	[L["Potion"]] = L["Potions"],
	[L["Blue Ogre Brew Special"]]= L["Potions"],  --Ogri'la
	[L["Red Ogre Brew Special"]] = L["Potions"],  --Ogri'la
	[L["Blue Ogre Brew"]]= L["Potions"],  --Ogri'la
	[L["Red Ogre Brew"]] = L["Potions"],  --Ogri'la
	[L["Bottled Nethergon Energy"]] = L["Potions"],  --Tempest Keep
	[L["Bottled Nethergon Vapor"]] = L["Potions"],   --Tempest Keep
	[L["Cenarion Mana Salve"]] = L["Potions"],   --Cenarion Expedition
	[L["Cenarion Healing Salve"]] = L["Potions"],   --enarion Expedition
	[L["Major Healing Draught"]] = L["Potions"],   --PvP
	[L["Major Mana Draught"]] = L["Potions"],   --PvP
	[L["Superior Mana Draught"]] = L["Potions"],   --PvP
	[L["Superior Healing Draught"]] = L["Potions"],   --PvP
}

local chainedCooldowns = {
	[(GetSpellInfo(11958))] = { -- 11958 Cold Snap
		(GetSpellInfo(120)), -- 120 Cone of Cold
		(GetSpellInfo(122)), -- 122 Frost Nova
		(GetSpellInfo(614)), -- 6143 Frost Ward
		(GetSpellInfo(11426)), -- 11426 Ice Barrier
		(GetSpellInfo(45438)), -- 45438 Ice Block
		(GetSpellInfo(31687)), -- 31687 Summon Water Elemental
	},
	[(GetSpellInfo(14185))] = { -- 14185 Preparation
		(GetSpellInfo(14177)), -- 14177 Cold Blood
		(GetSpellInfo(1725)), -- 1725 Distract
		(GetSpellInfo(5277)), -- 5277 Evasion
		(GetSpellInfo(1966)), -- 1966 Feint
		(GetSpellInfo(1776)), -- 1776 Gouge
		(GetSpellInfo(1766)), -- 1766 Kick
		(GetSpellInfo(408)), -- 408 Kidney Shot
		(GetSpellInfo(2983)), -- 2983 Sprint
		(GetSpellInfo(1856)), -- 1856 Vanish
	},
	[(GetSpellInfo(23989))] = { -- 23989 Readiness
		(GetSpellInfo(19577)), -- 19577 Intimidation
		(GetSpellInfo(34026)), -- 34026 Kill Command
		(GetSpellInfo(1513)), -- 1513 Scare Beast
		(GetSpellInfo(19434)), -- 19434 Aimed Shot
		(GetSpellInfo(3044)), -- 3044 Arcane Shot
		(GetSpellInfo(5116)), -- 5116 Concussive Shot
		(GetSpellInfo(20736)), -- 20736 Distracting Shot
		(GetSpellInfo(1534)), -- 1534 Flare
		(GetSpellInfo(2643)), -- 2643 Multi-Shot
		(GetSpellInfo(3045)), -- 3045 Rapid Fire
		(GetSpellInfo(19801)), -- 19801 Tranquilizing Shot
		(GetSpellInfo(3034)), -- 3034 Viper Sting
		(GetSpellInfo(1510)), -- 1510 Volley
		(GetSpellInfo(19306)), -- 19306 Counterattack
		(GetSpellInfo(19263)), -- 19263 Deterrence
		(GetSpellInfo(781)), -- 781 Disengage
		(GetSpellInfo(13813)), -- 13813 Explosive Trap
		(GetSpellInfo(5384)), -- 5384 Feign Death
		(GetSpellInfo(1499)), -- 1499 Freezing Trap
		(GetSpellInfo(13809)), -- 13809 Frost Trap
		(GetSpellInfo(13795)), -- 13795 Immolation Trap
		(GetSpellInfo(34477)), -- 34477 Misdirection
		(GetSpellInfo(1495)), -- 1495 Mongoose Bite
		(GetSpellInfo(2973)), -- 2973 Raptor Strike
		(GetSpellInfo(34600)), -- 34600 Snake Trap
		(GetSpellInfo(19386)), -- 19386 Wyvern Sting
	},
}

local schoolGroups = {
	["WARLOCK"] = {
		[STRING_SCHOOL_SHADOW] = (GetSpellInfo(686)), -- 686 Shadow Bolt 
		[STRING_SCHOOL_FIRE] = (GetSpellInfo(5676)), -- 5676 Searing Pain 
	},
	["MAGE"] = {
		[STRING_SCHOOL_ARCANE] = (GetSpellInfo(5143)), -- 5343 Arcane Missiles 
		[STRING_SCHOOL_FIRE] = (GetSpellInfo(133)), -- 133 Fireball
		[STRING_SCHOOL_FROST] = (GetSpellInfo(116)), -- 116 Frostbolt
	},
	["DRUID"] = {
		[STRING_SCHOOL_NATURE] = (GetSpellInfo(5185)), -- 5185 Healing Touch
	},
	["SHAMAN"] = {
		[STRING_SCHOOL_PHYSICAL] = (GetSpellInfo(3738)), -- 3738 Wrath of Air Totem 
		[STRING_SCHOOL_FIRE] = (GetSpellInfo(8227)), -- 8227 Flametongue Totem
		[STRING_SCHOOL_FROST] = (GetSpellInfo(5394)), -- 5394 Healing Stream Totem
		[STRING_SCHOOL_NATURE] = (GetSpellInfo(403)), -- 403 Lightning Bolt
	},
	["PRIEST"] = {
		[STRING_SCHOOL_SHADOW] = (GetSpellInfo(589)), -- 589 Shadow Word: Pain
		[STRING_SCHOOL_HOLY] = (GetSpellInfo(585)), --585 Smite
	},
	["PALADIN"] = {
		[STRING_SCHOOL_HOLY] = (GetSpellInfo(635)), -- 635 Holy Light
	},
}

-- Lists the spells that have a default cooldown, and the school they belong to
local schoolSpells = {
	["WARLOCK"] = {
		[(GetSpellInfo(6229))] = STRING_SCHOOL_SHADOW, -- 6229 Shadow Ward
		[(GetSpellInfo(5484))] = STRING_SCHOOL_SHADOW, -- 5484 Howl of Terror
		[(GetSpellInfo(17877))] = STRING_SCHOOL_SHADOW, -- 17877 Shadowburn
		[(GetSpellInfo(18540))] = STRING_SCHOOL_SHADOW, -- 18540 Ritual of Doom
		[(GetSpellInfo(603))] = STRING_SCHOOL_SHADOW, -- 603 Curse of Doom
		[(GetSpellInfo(698))] = STRING_SCHOOL_SHADOW, -- 698 Ritual of Summoning
		[(GetSpellInfo(29893))] = STRING_SCHOOL_SHADOW, -- 29893 Ritual of Souls
		[(GetSpellInfo(18288))] = STRING_SCHOOL_SHADOW, -- 18288 Amplify Curse
		[(GetSpellInfo(6789))] = STRING_SCHOOL_SHADOW, -- 6789 Death Coil
		[(GetSpellInfo(29858))] = STRING_SCHOOL_SHADOW, -- 29858 Soulshatter
		[(GetSpellInfo(1122))] = STRING_SCHOOL_SHADOW, -- 1122 Inferno
		[(GetSpellInfo(18708))] = STRING_SCHOOL_SHADOW, -- 18708 Fel Domination
		[(GetSpellInfo(48181))] = STRING_SCHOOL_SHADOW, -- 48181 Haunt
		[(GetSpellInfo(48020))] = STRING_SCHOOL_SHADOW, -- 48020 Demonic Circle: Teleport
		[(GetSpellInfo(48018))] = STRING_SCHOOL_SHADOW, -- 48018 Demonic Circle: Summon
		[(GetSpellInfo(48181))] = STRING_SCHOOL_SHADOW, -- 48181 Haunt 
		[(GetSpellInfo(47897))] = STRING_SCHOOL_SHADOW, -- 47897 Shadowflame
		[(GetSpellInfo(348))] = STRING_SCHOOL_FIRE, -- 348 Immolate
		[(GetSpellInfo(5676))] = STRING_SCHOOL_FIRE, -- 5676 Searing Pain
		[(GetSpellInfo(17962))] = STRING_SCHOOL_FIRE, -- 17962 Conflagrate
		[(GetSpellInfo(29722))] = STRING_SCHOOL_FIRE, -- 29722 Incinerate
		[(GetSpellInfo(5740))] = STRING_SCHOOL_FIRE, -- 5740 Rain of Fire
		[(GetSpellInfo(1949))] = STRING_SCHOOL_FIRE, -- 1949 Hellfire
	},
	["MAGE"] = {
		[(GetSpellInfo(122))] = STRING_SCHOOL_FROST, -- 122 Frost Nova
		[(GetSpellInfo(120))] = STRING_SCHOOL_FROST, -- 120 Cone of Cold
		[(GetSpellInfo(6143))] = STRING_SCHOOL_FROST, -- 6143 Frost Ward
		[(GetSpellInfo(11426))] = STRING_SCHOOL_FROST, -- 11426 Ice Barrier
		[(GetSpellInfo(45438))] = STRING_SCHOOL_FROST, -- 45438 Ice Block
		[(GetSpellInfo(31687))] = STRING_SCHOOL_FROST, -- 31687 Summon Water Elemental 

		[(GetSpellInfo(31661))] = STRING_SCHOOL_FIRE, -- 31661 Dragon's Breath
		[(GetSpellInfo(543))] = STRING_SCHOOL_FIRE, -- 543 Fire Ward
		[(GetSpellInfo(2136))] = STRING_SCHOOL_FIRE, -- 2136 Fire Blast
		[(GetSpellInfo(1831))] = STRING_SCHOOL_FIRE, -- 1831 Blast Wave

		[(GetSpellInfo(10059))] = STRING_SCHOOL_ARCANE, -- 10059 Portal: Stormwind
		[(GetSpellInfo(11416))] = STRING_SCHOOL_ARCANE, -- 11416 Portal: Ironforge
		[(GetSpellInfo(11419))] = STRING_SCHOOL_ARCANE, -- 11419 Portal: Darnassus
		[(GetSpellInfo(32266))] = STRING_SCHOOL_ARCANE, -- 32266 Portal: Exodar
		[(GetSpellInfo(11417))] = STRING_SCHOOL_ARCANE, -- 11417 Portal: Orgrimmar
		[(GetSpellInfo(32267))] = STRING_SCHOOL_ARCANE, -- 32267 Portal: Silvermoon
		[(GetSpellInfo(11420))] = STRING_SCHOOL_ARCANE, -- 11420 Portal: Thunder Bluff
		[(GetSpellInfo(11418))] = STRING_SCHOOL_ARCANE, -- 11418 Portal: Undercity
		[(GetSpellInfo(33691))] = STRING_SCHOOL_ARCANE, -- 33691 Portal: Shattrath

		[(GetSpellInfo(1953))] = STRING_SCHOOL_ARCANE, -- 1953 Blink
		[(GetSpellInfo(2139))] = STRING_SCHOOL_ARCANE, -- 2139 Counterspell
		[(GetSpellInfo(12051))] = STRING_SCHOOL_ARCANE, -- 12051 Evocation
		[(GetSpellInfo(12042))] = STRING_SCHOOL_ARCANE, -- 12042 Arcane Power
		[(GetSpellInfo(66))] = STRING_SCHOOL_ARCANE, -- 66 Invisibility
	},
	["DRUID"] = {
		[(GetSpellInfo(29166))] = STRING_SCHOOL_NATURE, -- 29166 Innervate
		[(GetSpellInfo(20484))] = STRING_SCHOOL_NATURE, -- 20484 Rebirth
		[(GetSpellInfo(16857))] = STRING_SCHOOL_NATURE, -- 16857 Faerie Fire (Feral)
		[(GetSpellInfo(740))] = STRING_SCHOOL_NATURE, -- 740 Tranquility
		[(GetSpellInfo(22812))] = STRING_SCHOOL_NATURE,  -- 22812 Barkskin
		[(GetSpellInfo(16689))] = STRING_SCHOOL_NATURE, -- 16689 Nature's Grasp
		[(GetSpellInfo(16914))] = STRING_SCHOOL_NATURE, -- 16914 Hurricane
	},
	["SHAMAN"] = {
		[(GetSpellInfo(16188))] = STRING_SCHOOL_PHYSICAL, -- 16188 Nature's Swiftness
		[(GetSpellInfo(30823))] = STRING_SCHOOL_PHYSICAL, -- 30823 Shamanistic Rage
		[(GetSpellInfo(17364))] = STRING_SCHOOL_PHYSICAL, -- 17364 Stormstrike
		[(GetSpellInfo(2894))] = STRING_SCHOOL_FIRE, -- 2894 Fire Elemental Totem
		[(GetSpellInfo(1535))] = STRING_SCHOOL_FIRE, -- 1535 Fire Nova Totem
		[(GetSpellInfo(8050))] = STRING_SCHOOL_FIRE, -- 8050 Flame Shock
		[(GetSpellInfo(8056))] = STRING_SCHOOL_FROST, -- 8056 Frost Shock
		[(GetSpellInfo(16190))] = STRING_SCHOOL_FROST, -- 16190 Mana Tide Totem
		[(GetSpellInfo(2062))] = STRING_SCHOOL_NATURE, -- 2062 Earth Elemental Totem
		[(GetSpellInfo(8042))] = STRING_SCHOOL_NATURE, -- 8042 Earth Shock
		[(GetSpellInfo(556))] = STRING_SCHOOL_NATURE, -- 556 Astral Recall
		[(GetSpellInfo(2825))] = STRING_SCHOOL_NATURE, -- 2825 Bloodlust
		[(GetSpellInfo(2484))] = STRING_SCHOOL_NATURE, -- 2484 Earthbind Totem
		[(GetSpellInfo(16166))] = STRING_SCHOOL_NATURE, -- 16166 Elemental Mastery
		[(GetSpellInfo(32182))] = STRING_SCHOOL_NATURE, -- 32182 Heroism
		[(GetSpellInfo(8177))] = STRING_SCHOOL_NATURE, -- 8177 Grounding Totem
		[(GetSpellInfo(20608))] = STRING_SCHOOL_NATURE, -- 20608 Reincarnation
		[(GetSpellInfo(5730))] = STRING_SCHOOL_NATURE, -- 5730 Stoneclaw Totem
		[(GetSpellInfo(421))] = STRING_SCHOOL_NATURE, -- 421 Chain Lightning
	},
	["PRIEST"] = {
		[(GetSpellInfo(586))] = STRING_SCHOOL_SHADOW, -- 586 Fade
		[(GetSpellInfo(589))] = STRING_SCHOOL_SHADOW, -- 589 Shadow Word: Pain
		[(GetSpellInfo(32379))] = STRING_SCHOOL_SHADOW, -- 32379 Shadow Word: Death
		[(GetSpellInfo(8092))] = STRING_SCHOOL_SHADOW, -- 8092 Mind Blast
		[(GetSpellInfo(15407))] = STRING_SCHOOL_SHADOW, -- 15407 Mind Flay
		[(GetSpellInfo(34433))] = STRING_SCHOOL_SHADOW, -- 34433 Shadowfiend
		[(GetSpellInfo(15286))] = STRING_SCHOOL_SHADOW, -- 15286 Vampiric Embrace
		[(GetSpellInfo(19238))] = STRING_SCHOOL_HOLY, -- 19238 Desperate Prayer
		[(GetSpellInfo(15263))] = STRING_SCHOOL_HOLY, -- 15263 Holy Fire
		[(GetSpellInfo(27870))] = STRING_SCHOOL_HOLY, -- 27870 Lightwell
		[(GetSpellInfo(33076))] = STRING_SCHOOL_HOLY, -- 33076 Prayer of Mending
		[(GetSpellInfo(34863))] = STRING_SCHOOL_HOLY, -- 34863 Circle of Healing
		[(GetSpellInfo(47540))] = STRING_SCHOOL_HOLY, -- 47540 Penance
		[(GetSpellInfo(64843))] = STRING_SCHOOL_HOLY, -- 64843 Divine Hymn
		[(GetSpellInfo(64901))] = STRING_SCHOOL_HOLY, -- 64901 Hymn of Hope
	},
	["PALADIN"] = {
		[(GetSpellInfo(20473))] = STRING_SCHOOL_HOLY, -- 20473 Holy Shock
		[(GetSpellInfo(642))] = STRING_SCHOOL_HOLY, -- 642 Divine Shield
		[(GetSpellInfo(498))] = STRING_SCHOOL_HOLY, -- 498 Divine Protection
		[(GetSpellInfo(31842))] = STRING_SCHOOL_HOLY, -- 31842 Divine Illumination
		[(GetSpellInfo(20216))] = STRING_SCHOOL_HOLY, -- 20216 Divine Favor
		[(GetSpellInfo(26573))] = STRING_SCHOOL_HOLY, -- 26573 Consecration
		[(GetSpellInfo(633))] = STRING_SCHOOL_HOLY, -- 633 Lay on Hands
		[(GetSpellInfo(2812))] = STRING_SCHOOL_HOLY, -- 2812 Holy Wrath
		[(GetSpellInfo(24275))] = STRING_SCHOOL_HOLY, -- 24275 Hammer of Wrath
		[(GetSpellInfo(879))] = STRING_SCHOOL_HOLY, -- 879 Exorcism
		[(GetSpellInfo(10326))] = STRING_SCHOOL_HOLY, -- 10326 Turn Evil
		[(GetSpellInfo(31789))] = STRING_SCHOOL_HOLY, -- 31789 Righteous Defense
		[(GetSpellInfo(31884))] = STRING_SCHOOL_HOLY, -- 31884 Avenging Wrath
		[(GetSpellInfo(20271))] = STRING_SCHOOL_HOLY, -- 20271 Judgement of Light
		[(GetSpellInfo(2812))] = STRING_SCHOOL_HOLY, -- 2812 Holy Wrath
		[(GetSpellInfo(853))] = STRING_SCHOOL_HOLY, -- 853 Hammer of Justice
		[(GetSpellInfo(19752))] = STRING_SCHOOL_HOLY, -- 19752 Divine Intervention
	},
}

local internalCooldowns = {
	[33370] = { -- 33370 Spell Haste
		time = 18, 
		item  = 27683, -- 27683 Quagmirran's Eye
	},
	[34321] = { -- 34321 Call of the Nexus
		time = 45,
		item = 27683, -- 27683 Shiffar's Nexus-Horn
	},
	[34775] = { -- 34775 Haste
		time = 20,
		item = 28830, -- 28830 Dragonspine Trophy
	},
	[34585] = { -- 34585 Love Struck
		time = 30,
		item = 28579, -- 28578 Masquerade Gown
	},
	[33649] = { -- 33649 Rage of the Unraveller
		time = 45,
		item = 28034, -- 28034 Hourglass of the Unraveller
	},
	[33370] = { -- 33370 Spell Haste
		time = 45,
		item = 28190, -- 28190 Scarab of the Infinite Cycle
	},
	[37174] = { -- 37174 Perceived Weakness
		time = 30, 
		item = 30450, -- 30450 Warp-Spring Coil
	},
	[38348] = { -- 38348 Unstable Currents
		time = 45,
		item = 30626, -- 30626 Sextant of Unstable Currents
	},
	[34597] = { -- 34597 Power of Arcanagos
		time = 45,
		item = 28602, -- 28602 Robe of the Elder Scribes
	},
	[42084] = { -- 42084 Fury of the Crashing Waves
		time = 45,
		item = 30627, -- 30627 Tsunami Talisman
	},
	[35078] = { -- 35078 Band of the Eternal Defender
		time = 45,
		item = 29297, -- 29297 Band of the Eternal Defender
	},
	[35081] = { -- 35081 Band of the Eternal Champion
		time = 45,
		item = 29301, -- 29301 Band of the Eternal Champion
	},
	[35084] = { -- 35084 Band of the Eternal Sage
		time = 45,
		item = 29305, -- 29305 Band of the Eternal Sage
	},
	[35087] = { -- 35987 Band of the Eternal Restorer
		time = 45,
		item = 29309, -- 29309 Band of the Eternal Restorer
	},
	[43837] = { -- 43837 Enlightenment, Crystalforge Raiment 4-set bonus
		time = 60,
	},
	[41435] = { -- 41435 The Twin Blades of Azzinoth
		time = 45,
	},
	[45478] = { -- 45478 Light's Salvation
		time = 45,
		item = 34677, -- 34677 Shattered Sun Pendant of Restoration (Aldor)
	},
	[45479] = { -- 45479 Light's Wrath
		time = 45,
		item = 34678, -- 34679 Shattered Sun Pendant of Acumen (Aldor)
	},
	[45480] = { -- 45480 Light's Strength
		time = 45,
		item = 34679, -- 34679 Shattered Sun Pendant of Might (Aldor)
	},
	[45432] = { -- 45432 Light's Ward
		time = 45,
		item = 34680, -- 34680 Shattered Sun Pendant of Resolve (Aldor)
	},
	[45478] = { -- 45430 Arcane Surge
		time = 45,
		item = 34677, -- 34677 Shattered Sun Pendant of Restoration (Scryer)
	},
	[45429] = { -- 45429 Arcane Bolt
		time = 45,
		item = 34678, -- 34679 Shattered Sun Pendant of Acumen (Scryer)
	},
	[45428] = { -- 45428 Arcane Strike 
		time = 45,
		item = 34679, -- 34679 Shattered Sun Pendant of Might (Scryer)
	},
	[45431] = { -- 45431 Arcane Insight
		time = 45,
		item = 34680, -- 34680 Shattered Sun Pendant of Resolve (Scryer)
	},
	[45058] = { -- 45058 Evasive Maneuvers
		time = 30,
		item = 34473, -- 34473 Commendation of Kael'thas
	},
	[37656] = { -- 37656 Wisdom
		time = 45,
		item = 32496, -- 32496 Memento of Tyrande
	},
	[45053] = { -- 45053 Disdain
		time = 45,
		item = 34472, -- 34472 Shard of Contempt
	},
	[45040] = { -- 45040 Battle Trance
		time = 45,
		item = 34427, -- 34427 Blackened Naaru Sliver
	},
	[60494] = { -- 60494 Dying Curse
		time = 45,
		item = 40255, -- 40255 Dying Curse
	},
}

local options = {
	type = "group",
	args = {
		toggle = {
			type = "execute",
			name = L["Toggle anchor"],
			desc = L["Toggle the bar anchor frame"],
			func = function()
					addon:ToggleAnchor()
				end,
		},
		test = {
			type = "execute",
			name = L["Test"],
			desc = L["Test bars"],
			func = function()
					addon:RunTest()
				end,
		},
		duration = {
			name = "Duration settings",
			desc = "Duration settings",
			type = "group",
			args = {
				min = {
					type = "input",
					name = L["Minimum duration"],
					desc = L["Minimum cooldown duration to display"],
					pattern = "%d+",
					get = function() return tostring(db.min) end,
					set = function(info, v) db.min = tonumber(v) end,
					order = 1,
				},
				max = {
					type = "input",
					name = L["Maximum duration"],
					desc = L["Maximum cooldown duration to display"],
					pattern = "%d+",
					get = function() return tostring(db.max) end,
					set = function(info, v) db.max = tonumber(v) end,
					order = 2, 
				},
			},
		},
		bars = {
			type = "group",
			name = L["Bar settings"],
			desc = L["Bar settings"],
			args = {
				growth = {
					type = "toggle",
					name = L["Grow upwards"],
					desc = L["Toggle bars grow upwards/downwards from anchor"],
					get = function () return db.growth end,
					set = function (info, v)
						db.growth = v
					end,
					order = 1,
				},
				width = {
					type = "range",
					name = L["Width"],
					desc = L["Set the width of the bars"],
					get = function() return db.width end,
					set = function(info, v)
							db.width = v
						end,
					min = 50,
					max = 500,
					step = 5,
					isPercent = false,
					order = 2,
				},
				height = {
					type = "range",
					name = L["Height"],
					desc = L["Set the height of the bars"],
					get = function() return db.height end,
					set = function(info, v)
							db.height = v
						end,
					min = 10,
					max = 100,
					step = 1,
					isPercent = false,
					order = 3,
				},
				scale = {
					type = "range",
					name = L["Scale"],
					desc = L["Set the scale of the bars"],
					get = function() return db.scale end,
					set = function(info, v)
							db.scale = v
						end,
					min = 0.1,
					max = 5,
					step = 0.01,
					isPercent = true,
					order = 4,
				},
				texture = {
					type = "select", dialogControl = 'LSM30_Statusbar',
					order = 6,
					name = L["Texture"],
					desc = L["Set the texture for the timer bars"],
					values = AceGUIWidgetLSMlists.statusbar,
					get = function() return db.texture end,
					set = function(i,v)
							db.texture = v
						end,
				},
				font = {
					type = "select", dialogControl = 'LSM30_Font',
					order = 6,
					name = L["Font"],
					desc = L["Set the bar font"],
					values = AceGUIWidgetLSMlists.font,
					get = function() return db.font end,
					set = function(i, v)
							db.font = v
						end,
					order = 7,
				},
				fontsize = {
					type = "range",
					name = L["Font Size"],
					desc = L["Set the bar font size"],
					min = 7,
					max = 48,
					step = 1,
					get = function(info) return db.fontsize end,
					set = function(info, value)
							db.fontsize = value
						end,
					order = 8,
				},
			},
			order = 10,
		},

		show = {
			type = "group",
			name = L["Show cooldowns"],
			desc = L["Toggle showing cooldown types"],
			args = {
				spells = {
					type = "group",
					name = L["Spells"],
					desc = L["Player spells cooldown options"],
					args = {
						enable = {
							type = "toggle",
							name = L["Enable player spells"],
							desc = L["Toggle showing player spells cooldowns"],
							get = function () return db.showSpells end,
							set = function (info, v)
									db.showSpells = v
									addon:SPELL_UPDATE_COOLDOWN()
								end,
							order = 10,
						},
						school = {
							type = "toggle",
							name = L["Show school"],
							desc = L["Spawns single bar if a school is locked out"],
							get = function () return db.school end,
							set = function (info, v)
									db.school = v
									addon:ScanSpells()
								end,
							disabled = function ()
									   return not db.showSpells
								   end,
							order = 100,
						},
					},
					order = 10,
				},
				petspells = {
					type = "toggle",
					name = L["Pet spells"],
					desc = L["Toggle showing pet cooldowns"],
					get = function () return db.showPet end,
					set = function (info, v)
						db.showPet = v
						addon:PET_BAR_UPDATE_COOLDOWN()
					end,
					order = 20,
				},
				equipped = {
					type = "toggle",
					name = L["Equipped items"],
					desc = L["Toggle showing equipped items cooldowns"],
					get = function () return db.showItems end,
					set = function (info, v)
						db.showItems = v
					end,
					order = 30,
				},
				bags = {
					type = "toggle",
					name = L["Inventory items"],
					desc = L["Toggle showing inventory items cooldowns"],
					get = function () return db.showBags end,
					set = function (info, v)
						db.showBags = v
					end,
					order = 40,
				},
				internal = {
					type = "toggle",
					name = L["Internal Cooldowns"],
					desc = L["Toggle showing item internal proc cooldowns"],
					get = function () return db.showInternal end,
					set = function (info, v)
						db.showInternal = v
					end,
					order = 40,
				},
			},
		},
	},
}

function addon:OnInitialize()
	AceConfig:RegisterOptionsTable("Heatsink", options)

	self.db = LibStub("AceDB-3.0"):New("HeatsinkDB", defaults, "Default")
	db = self.db.profile

	local optFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Heatsink", "Heatsink")
	options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(addon.db)

	self.db.RegisterCallback(self, "OnProfileChanged", function() db = self.db.profile end)

	self.spells = {}
	self.petspells = {}

	candy.RegisterCallback(self, "LibCandyBar_Stop", addon.BarStopped)
	
	addon.anchor = addon:CreateAnchor("HeatsinkAnchor", "Heatsink")
end

function addon:OnEnable()
	self:RegisterEvent("SPELLS_CHANGED")
	self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
	self:RegisterEvent("PET_BAR_UPDATE_COOLDOWN")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	self:RegisterEvent("BAG_UPDATE_COOLDOWN")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	playerGUID = UnitGUID("player")
	playerClass = select(2, UnitClass("player"))

	self:ScanSpells()
	self:ScanPetSpells()

	if db.showItems then
		self:ScanItems()
	end
	if db.showBags then
		self:ScanBags()
	end
end

function addon:OnDisable()
	self:UnregisterAllEvents()
end

local function colorNormal() return unpack(db.colors.bar) end
local function colorText() return unpack(db.colors.text) end
local function colorBackground() return unpack(db.colors.bg) end

local function barSorter(a, b)
	return a.remaining > b.remaining and true or false
end

local tmp = {}
function addon:RearrangeBars(anchor)
	wipe(tmp)
	for bar in pairs(anchor.bars) do
		tinsert(tmp, bar)
	end
	tsort(tmp, barSorter)
	local lastBar = nil
	local up = db.growth 
	for i, bar in ipairs(tmp) do
		bar:ClearAllPoints()
		if up then
			bar:SetPoint("BOTTOMLEFT", lastBar or anchor, "TOPLEFT")
			bar:SetPoint("BOTTOMRIGHT", lastBar or anchor, "TOPRIGHT")
		else
			bar:SetPoint("TOPLEFT", lastBar or anchor, "BOTTOMLEFT")
			bar:SetPoint("TOPRIGHT", lastBar or anchor, "BOTTOMRIGHT")
		end
		lastBar = bar
	end
end

function addon:GetBar(text)
	local bar = nil
	for k in pairs(addon.anchor.bars) do
		if k.candyBarLabel:GetText() == text then
			bar = true
		end
	end
	return bar
end

function addon:StopBars(text)
	local bar = nil
	for k in pairs(addon.anchor.bars) do
		if (not text or k.candyBarLabel:GetText() == text) then
			k:Stop()
			dirty = true
		end
	end
	return bar
end

function addon:Stop(text)
	local d = addon:StopBars(text)
	if d then addon:RearrangeBars(addon.anchor) end
end

local function onDragHandleMouseDown(self) self:GetParent():StartSizing("BOTTOMRIGHT") end
local function onDragHandleMouseUp(self, button) self:GetParent():StopMovingOrSizing() end
local function onResize(self, width)
	db.anchor.w = width
	addon:RearrangeBars(self)
end

local function onDragStart(self) self:StartMoving() end
local function onDragStop(self)
	self:StopMovingOrSizing()
	local s = self:GetEffectiveScale()
	db.anchor.x = self:GetLeft() * s
	db.anchor.y = self:GetTop() * s
end

local function onControlEnter(self)
	GameTooltip:ClearLines()
	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
	GameTooltip:AddLine(self.tooltipHeader)
	GameTooltip:AddLine(self.tooltipText, 1, 1, 1, 1)
	GameTooltip:Show()
end

local function onControlLeave() GameTooltip:Hide() end

function addon:CreateAnchor(frameName, title)
	local display = CreateFrame("Frame", frameName, UIParent)
	local w, x, y = frameName .. "_width", frameName .. "_x", frameName .. "_y"
	display.w, display.x, display.y = w, x, y
	display:EnableMouse(true)
	display:SetMovable(true)
	display:SetResizable(true)
	display:RegisterForDrag("LeftButton")
	display:SetWidth(db[w] or 200)
	display:SetHeight(20)
	display:SetMinResize(80, 20)
	display:SetMaxResize(1920, 20)
	display:ClearAllPoints()
	if db[x] and db[y] then
		local s = display:GetEffectiveScale()
		display:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", db[x] / s, db[y] / s)
	else
		display:SetPoint(unpack(defaults.profile.anchor.pos))
	end
	local bg = display:CreateTexture(nil, "PARENT")
	bg:SetAllPoints(display)
	bg:SetBlendMode("BLEND")
	bg:SetTexture(0, 0, 0, 0.3)
	local header = display:CreateFontString(nil, "OVERLAY")
	header:SetFontObject(GameFontNormal)
	header:SetText(title)
	header:SetAllPoints(display)
	header:SetJustifyH("CENTER")
	header:SetJustifyV("MIDDLE")
	local drag = CreateFrame("Frame", nil, display)
	drag:SetFrameLevel(display:GetFrameLevel() + 10)
	drag:SetWidth(16)
	drag:SetHeight(16)
	drag:SetPoint("BOTTOMRIGHT", display, -1, 1)
	drag:EnableMouse(true)
	drag:SetScript("OnMouseDown", onDragHandleMouseDown)
	drag:SetScript("OnMouseUp", onDragHandleMouseUp)
	drag:SetAlpha(0.5)
	local tex = drag:CreateTexture(nil, "BACKGROUND")
	tex:SetTexture("Interface\\AddOns\\Heatsink\\textures\\draghandle")
	tex:SetWidth(16)
	tex:SetHeight(16)
	tex:SetBlendMode("ADD")
	tex:SetPoint("CENTER", drag)
	local test = CreateFrame("Button", nil, display)
	test:SetPoint("BOTTOMLEFT", display, "BOTTOMLEFT", 3, 3)
	test:SetHeight(14)
	test:SetWidth(14)
	test.tooltipHeader = L["Test"]
	test.tooltipText = L["Creates a new test bar."]
	test:SetScript("OnEnter", onControlEnter)
	test:SetScript("OnLeave", onControlLeave)
	test:SetScript("OnClick", function() addon:RunTest() end)
	test:SetNormalTexture("Interface\\AddOns\\Heatsink\\textures\\test")
	local close = CreateFrame("Button", nil, display)
	close:SetPoint("BOTTOMLEFT", test, "BOTTOMRIGHT", 4, 0)
	close:SetHeight(14)
	close:SetWidth(14)
	close.tooltipHeader = L["Hide"]
	close.tooltipText = L["Hides the anchors."]
	close:SetScript("OnEnter", onControlEnter)
	close:SetScript("OnLeave", onControlLeave)
	close:SetScript("OnClick", function() addon:ToggleAnchor() end)
	close:SetNormalTexture("Interface\\AddOns\\Heatsink\\textures\\close")
	display:SetScript("OnSizeChanged", onResize)
	display:SetScript("OnDragStart", onDragStart)
	display:SetScript("OnDragStop", onDragStop)
--	display:SetScript("OnMouseDown", displayOnMouseDown)
	display.bars = {}
	display:Hide()
	return display
end

function addon:BarStopped(event, bar)
	if not bar then return end
	local a = bar:Get("anchor")
	if a and a.bars and a.bars[bar] then
		a.bars[bar] = nil
		addon:RearrangeBars(a)
	end
end

function addon:ToggleAnchor()
	if addon.anchor:IsShown() then
		addon.anchor:Hide()
	else
		addon.anchor:Show()
	end
end

function addon:ResetAnchor()
	addon.anchor:ClearAllPoints()
	addon.anchor:SetPoint(unpack(db.anchor.pos))
	db.anchor.pos.x = nil
	db.anchor.pos.y = nil
	db.anchor.pos.w = nil
	addon.anchor:SetWidth(db.anchor.width)
end


function addon:RunTest()
	local icon = select(3, GetSpellInfo(37412))
	local start = GetTime()
	addon:StartBar("Hourglass Test 5", start, 5, icon)
	addon:StartBar("Hourglass Test 10", start, 10, icon)
	addon:StartBar("Hourglass Test 15", start, 15, icon)
end

function addon:StartBar(text, start, duration, icon, spam)
	if spam and addon:GetBar(text) then return end
	local remaining = duration - (GetTime() - (start or 0))
	if remaining <= 0 then return end

	addon:Stop(text)
	local bar = candy:New(media:Fetch("statusbar", db.texture), 200, 14)
	addon.anchor.bars[bar] = true
	bar.candyBarBackground:SetVertexColor(colorBackground())
	bar:Set("anchor", addon.anchor)
	bar:SetColor(colorNormal())
	bar.candyBarLabel:SetTextColor(colorText())
	bar:SetLabel(text)
	bar:SetDuration(remaining)
	bar:SetTimeVisibility(true)
	bar:SetIcon(icon)
	bar:SetScale(db.scale)
	bar:Start()
	addon:RearrangeBars(bar:Get("anchor"))
end

function addon:SPELLS_CHANGED()
	self:ScanSpells()
	self:ScanPetSpells()
end

function addon:SPELL_UPDATE_COOLDOWN()
	if not db.showSpells then return end

	local schoolCooldown = {}
	if db.school and schoolGroups[playerClass] then
		for school, spell in pairs(schoolGroups[playerClass]) do
			local data = self.spells[spell]
			if data then
				local start, duration, active = GetSpellCooldown(data.id, BOOKTYPE_SPELL) 
				local icon = select(3, GetSpellInfo(data.id, BOOKTYPE_SPELL))
				if active == 1 and duration > db.min and duration <= db.max then
					schoolCooldown[school] = true
					self:StartBar(L["School"]:format(school), start, duration, icon, true)
				end
			end
		end
	end

	for name, spell in pairs(self.spells) do
		local start, duration, active = GetSpellCooldown(spell.id, BOOKTYPE_SPELL)
		if active == 1 and duration > db.min and duration <= db.max then
			if not db.school or not (spell.school and schoolCooldown[spell.school]) then
				self:StartBar(name, start, duration, spell.icon, true)
			end
		end
	end
end

function addon:PET_BAR_UPDATE_COOLDOWN()
	if not db.showPet then return end
	for name, spell in pairs(self.petspells) do
		local start, duration, active = GetSpellCooldown(spell.id, BOOKTYPE_PET)
		if active == 1 and duration > db.min and duration <= db.max then
			self:StartBar(name, start, duration, spell.icon, true)
		end
	end
end

function addon:UNIT_SPELLCAST_SUCCEEDED(event, unit, spellName)
	if unit == "player" and chainedCooldowns[spellName] then
		for _, chainedSpellName in pairs(chainedCooldowns[spellName]) do
			addon:Stop(chainedSpellName)
		end
	end
end

function addon:ZONE_CHANGED_NEW_AREA()
	local zone = GetRealZoneText()
	if not zone then
		self:ScheduleTimer(self.ZONE_CHANGED_NEW_AREA, 5, self)
	elseif IsActiveBattlefieldArena() then
		addon:Stop(addon.anchor.bars)
	end
end

function addon:UNIT_INVENTORY_CHANGED(event, unit)
	if unit == "player" then
		if db.showItems then
			self:ScanItems()
		end
		if db.showBags then
			self:ScanBags()
		end
	end
end

function addon:BAG_UPDATE_COOLDOWN(event, container)
	if db.showItems then
		self:ScanItems()
	end
	if db.showBags then
		self:ScanBags()
	end
end

function addon:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, eventType, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellID, spellName, spellFlags, ...)
	if not db.showInternal or dstGUID ~= playerGUID then return end
	if (eventType ~= "SPELL_AURA_APPLIED" and eventType ~= "SPELL_CAST_SUCESS") then return end
	if not internalCooldowns[spellID] then return end

	local duration = internalCooldowns[spellID].time
	if not duration then return end

	local name, icon

	if internalCooldowns[spellID].item then
		local itemName, _, _, _, _, _, _, _, _, itemIcon = GetItemInfo(internalCooldowns[spellID].item)
		name = itemName
		icon = itemIcon
	else
		name = spellName
		local _,_,spellIcon = GetSpellInfo(spellID)
		icon = spellIcon
	end

	self:StartBar(name, GetTime(), duration, icon)
end

function addon:ScanSpells()
	self.spells = {}

	local i = 1

	local spellName = GetSpellInfo(i, BOOKTYPE_SPELL)
	local previousSpellName

	local schoolEnabled = db.school

	while spellName do
		if spellName ~= previousSpellName then
			for k, v in pairs(groupedCooldowns) do
				if spellName == k then
					spellName = v
					break
				end
			end

			Gratuity:SetSpell(i, BOOKTYPE_SPELL)
			if Gratuity:Find("cooldown", 2, 3, true) then
				self.spells[spellName] = {
					id = i,
					icon = select(3, GetSpellInfo(i, BOOKTYPE_SPELL)),
					startTime = 0,
				}

				if schoolEnabled and schoolSpells[playerClass] and schoolSpells[playerClass][spellName] then
					self.spells[spellName]["school"] = schoolSpells[playerClass][spellName]
				end
			else
				if schoolEnabled and schoolGroups[playerClass] then
					for school, spell in pairs(schoolGroups[playerClass]) do
						if (spellName == spell) then
							self.spells[spellName] = {
								id = i,
								icon = select(3, GetSpellInfo(i, BOOKTYPE_SPELL)),
								startTime = 0,
								school = school,
							}
							break
						end
					end
				end
			end
		end

		i = i + 1
		previousSpellName = spellName
		spellName = GetSpellInfo(i, BOOKTYPE_SPELL)
	end

	self:SPELL_UPDATE_COOLDOWN()
end

function addon:ScanPetSpells()
	self.petspells = {}

	local i = 1
	local spellName = GetSpellInfo(i, BOOKTYPE_PET)
	local previousSpellName

	while spellName do
		if spellName ~= previousSpellName then

			Gratuity:SetSpell(i, BOOKTYPE_PET)
			if Gratuity:Find("cooldown", 2, 3, true) then
				self.petspells[spellName] = {
					id = i,
					icon = select(3, GetSpellInfo(i, BOOKTYPE_PET)),
					startTime = 0,
				}
			end
		end

		i = i + 1
		previousSpellName = spellName
		spellName = GetSpellInfo(i, BOOKTYPE_PET)
	end

	self:PET_BAR_UPDATE_COOLDOWN()
end

function addon:ScanItems()
	for _, slotName in pairs(itemSlots) do
		local slotId = GetInventorySlotInfo(slotName)
		local start, duration, active = GetInventoryItemCooldown("player", slotId)
		if active == 1 and duration > db.min and duration <= db.max then
			local name = select(3, GetInventoryItemLink("player", slotId):find("Hitem[^|]+|h%[([^[]+)%]"))
			local icon = GetInventoryItemTexture("player", slotId)
			self:StartBar(name, start, duration, icon)
		end
	end
end

function addon:ScanBags()
	for bag = 0,4 do
		local slots = GetContainerNumSlots(bag)
		for slot = 1,slots do
			local start, duration, active = GetContainerItemCooldown(bag,slot)
			if active == 1 and duration > db.min and duration <= db.max then
				local name = select(3, GetContainerItemLink(bag,slot):find("Hitem[^|]+|h%[([^[]+)%]"))
				local icon = GetContainerItemInfo(bag, slot)
				for pattern, replacement in pairs(groupedBagCooldowns) do
					if (string.find(name, pattern)) then
						name = replacement
						break
					end
				end
				local remaining = GetTime() - start
				self:StartBar(name, start, duration, icon)
			end
		end
	end
end
